Dynamic Link Exchange Protocol (DLEP) Link Identifier Extension
RFC 0000
Rick Taylor
Airbus Defence & Space
Quadrant House
Celtic Springs
Coedkernew
Newport
NP10 8FZ
United Kingdom
rick.taylor@airbus.com
Stan Ratliff
VT iDirect
13861 Sunrise Valley Drive, Suite 300
Herndon
VA
20171
United States of America
sratliff@idirect.net
December 2019
Routing
Mobile Ad hoc Networks Working Group
example
The Dynamic Link Exchange Protocol (DLEP) (RFC 8175) describes a protocol for modems to advertise the status of wireless links between reachable destinations to attached routers. The core specification of the protocol assumes that every modem in the radio network has an attached DLEP router and requires that the Media Access Control (MAC) address of the DLEP interface on the attached router be used to identify the destination in the network, for purposes of reporting the state and quality of the link to that destination.
This document describes a DLEP Extension that allows modems that do not meet the strict requirement above to use DLEP to describe link availability and quality to one or more destinations reachable beyond a device on the Layer 2 domain.
Introduction
The Dynamic Link Exchange Protocol (DLEP) [RFC8175] describes a protocol for modems to advertise the status of wireless links between reachable destinations to attached routers. The core specification of the protocol assumes that every modem in the radio network has an attached DLEP router and requires that the MAC address of the DLEP interface on the attached router be used to identify the destination in the network, for purposes of reporting the state and quality of the link to that destination.
This document describes a DLEP Extension that allows modems that do not meet the strict requirement above to use DLEP to describe link availability and quality to one or more destinations reachable beyond a device on the Layer 2 domain.
As with core DLEP, a router can use this knowledge to influence any routing or flow-control decisions regarding traffic to this destination, understanding that such traffic flows via Layer 3.
Terminology
Local Layer 2 domain:
The Layer 2 domain that links the router and modem participants of the current DLEP session.
Layer 3 DLEP Destination:
A DLEP Destination that is not directly addressable within the local Layer 2 domain but is reachable via a node addressable within the local Layer 2 domain.
Gateway node:
The last device with a MAC address reachable in the local Layer 2 domain on the path from the DLEP router participant, towards the Layer 3 DLEP Destination. This device is commonly the DLEP peer modem but could be another DLEP Destination in the Layer 2 domain.
Applicability
This extension was designed primarily to address the following use cases:
1. A radio system that does not operate in Layer 2 bridge mode but instead provides Layer 3 connectivity between destinations, often using its own embedded Layer 3 routing function.
2. A point-to-multipoint tunnel system, such as a(n) software-defined wide-area network (SD-WAN) deployment, where the tunnel provider acts as a modem that has knowledge of the characteristics of the underlay network and provides that information as availability and metrics between tunnel endpoints in the overlay network.
3. A modem that provides connectivity to a remote wide-area network via a wireless link, but the concept of a Layer 2 reachable remote router does not apply. An example of such a modem would be an LTE device or 802.11 station that provides variable connectivity to the Internet.
This list of use cases is not exhaustive, and this extension may well be applicable to future, currently unforeseen, use cases.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Operation
To refer to a Layer 3 DLEP Destination, the DLEP session participant adds a Link Identifier Data Item (Section 3.2) to the relevant Destination Message and (as usual) includes a MAC Address Data Item. When paired with a Link Identifier Data Item, the MAC Address Data Item MUST contain the MAC address of the gateway node.
As only modems are initially aware of Layer 3 DLEP Destinations, Link Identifier Data Items referring to a new link MUST first appear in a DLEP Destination Up Message from the modem to the router. Once a link has been identified in this way, Link Identifier Data Items may be used by either DLEP participant during the lifetime of a DLEP session. Because of this, a router MUST NOT send a DLEP Destination Announce Message containing a Link Identifier Data Item referring to a link that has not been mentioned in a prior DLEP Destination Up Message. If a modem receives such a message, it MUST terminate the session by issuing a Session Termination Message containing a Status Data Item with status code set to 131 'Invalid Destination' and transition to the Session Termination state. If a router receives a Destination Up Message specifying a Link Identifier that has already been used, the router MUST respond with a Destination Up Response Message containing a Status Data Item with status code set to 130 'Invalid Data' and transition to the Session Termination state.
Because the MAC Address associated with any DLEP Destination Message containing a Link Identifier Data Item is not the Layer 2 address of the final destination, all DLEP Destination Up Messages containing a Link Identifier Data Item MUST contain Layer 3 information. In the case of modems that provide Layer 3 wide area network connectivity between devices, one or more IPv4 or IPv6 Address Data Items will provide the Layer 3 address of the final destination. When referring to some upstream backbone network infrastructure, this indicates one or more IPv4 or IPv6 Attached Subnet Data Items, for example: '0.0.0.0/0' or '::/0'. This allows the DLEP peer router to understand the properties of the link to those routes. The address or addresses in the IPv4 or IPv6 Address Data Items MUST be the addresses in use on the public side of any Network Address Translation.
When the DLEP peer router wishes to route packets to the Layer 3 DLEP Destination, the MAC address associated with the gateway node MUST be used as the Layer 2 destination of the packet if it wishes to use the modem network to forward the packet.
As routers populate their Routing Information Base with the IP address of the next hop router towards a destination, implementations supporting this extension SHOULD announce at least one valid IPv4 or IPv6 addresses of the gateway node; this removes the need for the router to use an additional IP address resolution protocol before adding the route to its Routing Information Base.
Identifier Restrictions
A Link Identifier is, by default, 4 octets in length. If a modem wishes to use a Link Identifier of a different length, it MUST be announced using the Link Identifier Length Data Item (Section 3.1) contained in the DLEP Session Initialization Response Message sent by the modem to the router.
During the lifetime of a DLEP session, the length of Link Identifiers MUST remain constant, i.e., the Length field of the Link Identifier Data Item MUST NOT differ between destinations.
The method for generating Link Identifiers is a modem implementation matter and out of scope of this document. Routers must not make any assumptions about the meaning of Link Identifiers or how Link Identifiers are generated.
Within a single DLEP session, all Link Identifiers MUST be unique per MAC Address. This means that a Layer 3 DLEP Destination is uniquely identified by the pair: {MAC Address,Link Identifier}.
Link Identifiers MUST NOT be reused, i.e., a {MAC Address,Link Identifier} pair that has been used to refer to one Layer 3 DLEP Destination MUST NOT be used again within the lifetime of a single DLEP peer-to-peer session.
Negotiation
To use this extension, as with all DLEP extensions, the extension MUST be announced during DLEP session initialization. A router advertises support by including the value 'Link Identifiers', TBD1 (Section 5), in the Extension Data Item within the Session Initialization Message. A modem advertises support by including the value 'Link Identifiers' in the Extension Data Item within the Session Initialization Response Message. If both DLEP peers advertise support for this extension, then Link Identifier Data Items can be included in DLEP Messages.
If a modem requires support for this extension in order to describe destinations and the router does not advertise support, then the modem MUST NOT include a Link Identifier Data Item in any DLEP Message. However, the modem SHOULD NOT immediately terminate the DLEP session, rather it SHOULD use a combination of DLEP Session Messages and DLEP Attached Subnet Data Items to provide general information.
New Data Items
This extension introduces two new DLEP Data Items: the Link Identifier Data Item (Section 3.2) used to identify a Layer 3 link at or beyond a destination and the Link Identifier Length Data Item (Section 3.1) used to announce the length of Link Identifiers at session initialization.
Link Identifier Length Data Item
The Link Identifier Length Data Item is used by a DLEP modem implementation to specify the length of Link Identifier Data Items. If the router advertised support by including the value 'Link Identifiers' in the Extension Data Item inside the Session Initialization Message, this data item MAY be used in the Session Initialization Response Message if the specified length is not the default value of 4 octets. If the router did not specify support by including the value 'Link Identifiers' in the Extension Data item, this Data Item MUST NOT be sent.

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| Data Item Type                | Length                        |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| Link Identifier Length        |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Data Item Type:
TBD2 (Section 5)
Length:
2
Link Identifier Length:
The length, in octets, of Link Identifiers used by the DLEP modem for this session.
A Link Identifier Length Data Item that specifies a Link Identifier Length of 4 octets (the default) is valid, even if it has no effect.
Link Identifier Data Item
The Link Identifier Data Item MAY be used wherever a MAC Address Data Item is defined as usable in core DLEP.

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| Data Item Type                | Length                        |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                   Link Identifier...                          :
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Data Item Type:
TBD3 (Section 5)
Length:
The length of the Data Item, by default 4, but may be different if a Link Identifier Length Data Item (Section 3.1) has been announced during session initialization.
Link Identifier:
The unique identifier of the Layer 3 DLEP Destination. This Link Identifier has no implicit meaning and is only used to discriminate between multiple links.
Security Considerations
As an extension to the core DLEP, the security considerations of that protocol apply to this extension. This extension adds no additional security mechanisms or features.
None of the features introduced by this extension require extra security consideration by an implementation.
IANA Considerations
Upon approval of this document, IANA is requested to:
- Assign a new DLEP Extensions Type Registry value (TBD1) from the Specification Required section, named "Link Identifiers".
- Assign a new DLEP Data Item Type Values Registry value (TBD2) from the Specification Required section, named "Link Identifier Length".
- Assign a new DLEP Data Item Type Values Registry value (TBD3) from the Specification Required section, named "Link Identifier".
Normative References
[RFC8175]
[RFC2119]
[RFC8174]